# Perl Wmqi message dump and invert field character values
use wmqi;
# Get hold of the root of the input message
$inputroot = wmqi::RootElement($wmqi::inputMessage);

print "input ",$inputroot,"\n";  


print "Create output message\n";
$outputMessage=wmqi::CreateMessage();

print "Get output root",$outputMessage,"\n";
$outputroot=wmqi::RootElement($outputMessage);

print "Copy input message to output",$outputroot," ,rc:",$wmqi::retcode,"\n";
wmqi::CopyElementTree($inputroot, $outputroot);

print "Get xml element rc=",$wmqi::retcode,"\n";
$xml=wmqi::LastChild($outputroot);

$xmlroot=wmqi::FirstChild($xml);

print "Add new element\n";
# Add a new element to the xml tree
$newelement = wmqi::CreateElementAsLastChild($xmlroot);
wmqi::SetElementName($newelement,"new_element");
$newvalue = wmqi::CreateElementAsLastChild($newelement);
wmqi::SetElementCharacterValue($newvalue,"eulav wen a si siht");

print "Add new date element\n";
# Add a new date element to the xml tree
$newelement = wmqi::CreateElementAsLastChild($xmlroot);
wmqi::SetElementName($newelement,"new_date_element");
$newvalue = wmqi::CreateElementAsLastChild($newelement);
wmqi::SetElementDateValue($newvalue,2002,10,30);

print "Add new time stamp element\n";
# Add a new timestamp element to the xml tree
$newelement = wmqi::CreateElementAsLastChild($xmlroot);
wmqi::SetElementName($newelement,"new_timestamp_element");
$tsvalue = wmqi::CreateElementAsLastChild($newelement);
wmqi::SetElementTimestampValue($tsvalue,2002,10,30,15,45,21);

print "Get back new time stamp \n";
($y,$m,$d,$h,$m,$s)= @{&wmqi::ElementTimestampValue($tsvalue)};
print "Value year ", $y , "\n" ;


# traverse tree and reverse values 
print "call traverse tree and reverse values ",$xml,"\n";
reverse($xml);
dumptree($xml);

print "call propagate \n";
wmqi::Propagate($outputMessage);
print "Propagate rc:",$wmqi::retcode,"\n";


# Now test SQL statements 
$exp=wmqi::SqlCreateStatement("MQSIBKDB",1,"SET OutputRoot.XML.tables.name[] = (SELECT T.NAME FROM Database.SYSIBM.SYSTABLES AS T);");
wmqi::SqlSelect($exp,$outputMessage);
print "Get output root",$outputMessage,"\n";
$outputroot=wmqi::RootElement($outputMessage);
print "Get xml element rc=",$wmqi::retcode,"\n";
$xml=wmqi::LastChild($outputroot);
# traverse tree 
print "call traverse tree ",$xml,"\n";
dumptree($xml);
wmqi::DeleteMessage($outputMessage);

# end of program

# Sample subroutine to dump Wmqi message tree 

sub dumptree {
    print "\n-------\n";
    my ($element) = @_;
    my $content=wmqi::FirstChild($element);
    while ($content) {
	my $type=wmqi::ElementType($content);
	printf "type : %x %x \n", ($type>>24) & 0xFF, $type;
	my $name = wmqi::ElementName($content);
	if (($type & $wmqi::NAME) and $name ) {
		print "tag name : ", $name ,"\n";
	}
	my $value = wmqi::ElementCharacterValue($content);
	if (($type & $wmqi::VALUE) and $value) {
		print "value  : ", $value ,"\n";
	}
	dumptree($content);
	$content=wmqi::NextSibling($content);
    }
}

# Sample subroutine to scan Wmqi message tree and reverse the string values in the output message
# eg: an input message <d>123<e>abc</e><f>def</f>456</d>
#     will become      <d>321<e>cba</e><f>fed</f>654</d>

sub reverse {
    my ($element) = @_;
    my $content=wmqi::FirstChild($element);
    while ($content) {
	my $type=wmqi::ElementType($content);
	my $name = wmqi::ElementName($content);
	my $value = wmqi::ElementCharacterValue($content);
	if (($type & $wmqi::VALUE) and $value) {
		my $newvalue = reverse($value);
		wmqi::SetElementCharacterValue($content,$newvalue);
	}
	dumptree($content);
	$content=wmqi::NextSibling($content);
    }
}